// mprog.h
// (C) Copyright 1995,2001  Jed Margolin  All Rights Reserved
// Demo Program for 3D Unit Vectors 
//------------------------------------------------------------------------
// color table
struct ctable		
{
	float r,g,b;	
};

	
struct ctable lctable[8]=
{
	{ 0.0f,0.0f,0.0f }, // color 0  Black
	{ 1.0f,0.0f,0.0f },	// color 1  Red
	{ 0.0f,1.0f,0.0f },	// color 2  Green
	{ 0.0f,0.0f,1.0f },	// color 3  Blue
	{ 0.0f,1.0f,1.0f },	// color 4  Cyan
	{ 1.0f,0.0f,1.0f },	// color 5  Magenta
	{ 1.0f,1.0f,0.0f },	// color 6  Yellow
	{ 1.0f,1.0f,1.0f },	// color 7  White
};	


#define BLACK	0
#define RED		1
#define GREEN	2
#define BLUE	3
#define CYAN	4
#define MAGENTA 5
#define YELLOW	6
#define WHITE	7
//------------------------------------------------------------------------
// Main Menu Table 
#define NUM_ENTRIES	11
#define XM		3

int mexit(void),poly_perpgm(void),poly_orthpgm(void),wf_perpgm(void);
int wf_orthpgm(void),instr_pgm(void);

struct tentry 
{
	int xpos;
	int ypos;			// Menu Coordinates 
	char msg[60];		// Menu Message
	int obj;			// type of object
	int (*pgm)(void);	// object program to call
	float xt;			// translation value
};
	
struct tentry mtable[NUM_ENTRIES]=
{
   { XM, 4, "EXIT", 0, mexit, 800. },

   { XM,  6, "Square      Polygon       Perspective Projection",
     0, poly_perpgm, 800. },

   { XM,  7, "Cube        Polygon       Perspective Projection",
     1, poly_perpgm, 800. },

   { XM,  8, "Airplane    Polygon       Perspective Projection",
     2, poly_perpgm, 800. },

   { XM, 10, "Square      Polygon       Orthographic Projection",
     0, poly_orthpgm, 800. },

   { XM, 11, "Cube        Polygon       Orthographic Projection",
     1, poly_orthpgm, 800. },

   { XM, 12, "Airplane    Polygon       Orthographic Projection",
     2, poly_orthpgm, 800. },

   { XM, 14, "Square      Wire Frame    Perspective Projection",
     0, wf_perpgm, 800. },

   { XM, 15, "Cube        Wire Frame    Perspective Projection",
     1, wf_perpgm, 800. },

   { XM, 16, "Airplane    Wire Frame    Perspective Projection",
     2, wf_perpgm, 800. },

   { XM, 18, "Instructions", 0, instr_pgm, 200. },

};	

// -----------------------------------------------------------------------
struct dirstr 
{
	int xpos;
	int ypos;		    // Message Coordinates 
	int color;
	char msg[80];		// Message
};

#define NUM_INSTR	15	
struct dirstr dirmsgs[NUM_INSTR]=
{
   { 3,1,MAGENTA,"Directions:" },
   { 3,3,WHITE,"Lissajous Patterns" },
   { 5,4,YELLOW,"<Right Arrow> increases the phase rotation by a small amount." },
   { 5,5,YELLOW,"<Left Arrow> decreases the phase rotation by a small amount." },
   { 5,6,YELLOW,"<Up Arrow> increases the phase rotation by an integer amount." },
   { 5,7,YELLOW,"<Dn Arrow> decreases the phase rotation by an integer amount." },
   { 5,8,YELLOW,"PgUp and PgDn change the color of the figure." },
   { 5,9,YELLOW,"Ctl<PgUp> and Ctl<PgDn> change the color of the background." },
   { 3,11,WHITE,"Color Bars are the combinations of Red, Green, and Blue." },
   { 3,13,WHITE,"Crosshatch and Dot Patterns show how well the monitor is converged." },
   { 5,14,YELLOW,"PgUp and PgDn change the color of grid lines or dots." },
   { 5,15,YELLOW,"Ctl<PgUp> and Ctl<PgDn> change the color of the background." },
   { 3,17,WHITE,"HV Test challenges Monitor HV Regulation by changing the beam current." },
   { 5,18,YELLOW,"PgUp and PgDn change Color 1." },
   { 5,19,YELLOW,"Ctl<PgUp> and Ctl<PgDn> change Color 2." },
};


// Instruction messages
#define NUM_MSGS	8

struct instrmsg 
{
	int xpos;
	int ypos;			// Menu Coordinates
	int color;
	char msg[60];		// Instruction Message
};
	
struct instrmsg msgtable[NUM_MSGS]=
{
   { 0,3,GREEN,"Object's Frame of Reference" },
   { 0,4,BLUE,"Roll: Left Arrow, Right Arrow" },
   { 0,5,BLUE,"Pitch: Up Arrow, Down Arrow"},
   { 0,6,BLUE,"Yaw: End, Pg Dn"},
   { 36,3,GREEN,"Universe's Frame of Reference" },
   { 36,4,BLUE,"Roll: CTL Left Arrow, CTL Right Arrow" },
   { 36,5,BLUE,"Pitch: CTL Up Arrow, CTL Down Arrow" },
   { 36,6,BLUE,"Yaw: CTL End, CTL Pg Dn"},
};


/* Virtual Keys:
	VK_SPACE
	VK_PRIOR
	VK_NEXT 
	VK_END  
	VK_HOME 
	VK_LEFT 
	VK_UP   
	VK_RIGHT
	VK_DOWN 
	VK_SELECT
	VK_PRINT 
	VK_EXECUTE
	VK_SNAPSHOT
	VK_INSERT  
	VK_DELETE  
*/
