// objects.h 
// Jed Margolin 1995, 2001 
// Objects for program to demonstrate 3D Unit Vector Math
// color table


struct gltable		
{
	float r,g,b;	
};

	
struct gltable ctable[16]=
{
	{ 0.00f,0.00f,0.00f },  // color 0  Black
	{ 0.00f,0.00f,1.00f },	// color 1  Blue
	{ 0.00f,1.00f,0.00f },	// color 2  Green
	{ 0.00f,1.00f,1.00f },	// color 3  Cyan
	{ 1.00f,0.00f,0.00f },	// color 4  Red
	{ 1.00f,0.00f,1.00f },	// color 5  Magenta
	{ 0.60f,0.40f,0.12f },	// color 6  Brown
	{ 0.75f,0.75f,0.75f },	// color 7  Light Gray
	{ 0.25f,0.25f,0.25f },	// color 8  Dark Gray
	{ 0.75f,0.00f,0.00f },	// color 9  Light Blue
	{ 0.00f,0.75f,0.00f },	// color 10 Light Green
	{ 0.00f,0.75f,0.75f },	// color 11 Light Cyan
	{ 0.75f,0.00f,0.00f },	// color 12 Light Red
	{ 0.75f,0.00f,0.75f },	// color 13 Light Magenta
	{ 1.00f,1.00f,0.00f },	// color 14 Yellow
	{ 1.00f,1.00f,1.00f },	// color 15 White
};	


#define C0    0		// black
#define C1    1		// blue 
#define C2    2		// green
#define C3    3		// cyan 
#define C4    4		// red  
#define C5    5		// magenta
#define C6    6		// brown 
#define C7    7		// light gray
#define C8    8		// dark gray 
#define C9    9		// light blue
#define C10  10		// light green
#define C11  11		// light cyan 
#define C12  12		// light red 
#define C13  13		// light magenta
#define C14  14		// yellow
#define C15  15		// white 
// ========================================================================
float outx[100],outy[100],outz[100],axout[100],ayout[100],azout[100];
// ========================================================================
// The Square has 4 Points
int SQ_P[4*3+1] = { 4,		
					0,100,100,	
					0,-100,100,	
					0,-100,-100,	
					0,100,-100		};	
// ---------------------------------
// Connect list for wire frame
int SQLINES[8] = { 1,
			  	  C1,0,1,2,3,0,-1	};
// --------------------------------- 
// Square Normals
int SQNORMS[2*3+1] = { 2,
				 	-100,0,0,
					 100,0,0		};
// ---------------------------------
// Square Faces
int SQFACES[15] = { 2,
		    C1,0,1,2,3,0,-1,
		    C4,0,3,2,1,0,-1    };
// ---------------------------------
// Connect the normals to a vertex
int SQNORGS[2] = { 0,
		   0  };
// ------------------------------------------------------------------------
// ------------------------------------------------------------------------
// The Cube has 8 Points
int CUBE_P[8*3+1] = { 8, 	
		    -100,-100,-100,
		    100,-100,-100,
		    100,100,-100,
		    -100,100,-100,
		    -100,-100,100,
		    100,-100,100,
		    100,100,100,
		    -100,100,100 };
// ---------------------------------
// Connect list for wire frame
int CLINES[19] = { 1,
		  C1,0,1,2,3,0,4,5,1,5,6,2,6,7,3,7,4,-1 };
// ---------------------------------
// Cube Normals
int CNORMS[6*3+1] = { 6,		
		-100,0,0,	// Face 1
		0,100,0,	// Face 2
		100,0,0,	// Face 3
		0,-100,0,	// Face 4
		0,0,-100,	// Face 5
		0,0,+100 };	// Face 6
// ---------------------------------
// Cube Faces
int CFACES[7*6+1] = { 6,
		    C1,0,3,7,4,0,-1,		// Face 1
		    C2,2,6,7,3,2,-1,		// Face 2
		    C3,1,5,6,2,1,-1,		// Face 3
		    C4,0,4,5,1,0,-1,		// Face 4
		    C5,1,2,3,0,1,-1,		// Face 5
		    C6,7,6,5,4,7,-1 };		// Face 6
// ---------------------------------
// Connect the normals to a vertex
int CNORGS[6] = { 0,
		  2,
		  1,
		  0,
		  1,
		  7 };
// ------------------------------------------------------------------------
// ------------------------------------------------------------------------
#define AC  2		// for object scaling
// The Airplane has 25 points
int AIR[25*3+1] = { 25,
	      144*AC,0*AC,0*AC,		// Point 0  
	      72*AC,-12*AC,0*AC,	// Point 1  	
	      80*AC,-5*AC,9*AC,		// Point 2  
	      80*AC,5*AC,9*AC,		// Point 3  
	      72*AC,12*AC,0*AC,		// Point 4  
	      48*AC,-16*AC,0*AC,	// Point 5  
	      40*AC,-8*AC,16*AC,	// Point 6  
	      40*AC,8*AC,16*AC,		// Point 7  
	      48*AC,16*AC,0*AC,		// Point 8  
	      40*AC,-8*AC,-16*AC,	// Point 9  
	      40*AC,8*AC,-16*AC,	// Point 10 
	      0*AC,-80*AC,-8*AC,	// Point 11 
	      0*AC,80*AC,-8*AC,		// Point 12 
	      24*AC,0*AC,16*AC,		// Point 13 
	     -24*AC,0*AC,32*AC,		// Point 14 
	     -48*AC,0*AC,32*AC,		// Point 15 
	     -64*AC,0*AC,16*AC,		// Point 16 
	     -48*AC,-80*AC,-8*AC,	// Point 17 
	     -48*AC,80*AC,-8*AC,	// Point 18 
	     -72*AC,-16*AC,0*AC,	// Point 19 
	     -72*AC,16*AC,0*AC,		// Point 20 
	     -64*AC,-8*AC,16*AC,	// Point 21 
	     -64*AC,-8*AC,-16*AC,	// Point 22 
	     -64*AC,8*AC,16*AC,		// Point 23 
	     -64*AC,8*AC,-16*AC };	// Point 24 
// ---------------------------------
// Connect list for wire frame
int AIRLINES[66] = { 7,
		C1,5,0,6,7,0,8,10,0,9,5,-1,
		C1,1,2,3,4,-1,
		C1,8,7,23,20,8,12,18,20,24,18,-1,
		C1,12,10,-1,
		C1,5,6,21,19,5,11,17,19,22,17,-1,
		C1,11,9,22,21,16,13,14,15,16,23,24,22,-1,
		C1,24,10,9,-1  };
// ---------------------------------
// Airplane normals  
int AIRNORMS[26*3+1] = {	26,
		2288,13729,8644,	// 0,4,3     
		2282,0,16224,		// 0,3,2     
		2288,-13729,8644,	// 0,2,1     
		2824,0,16139,		// 7,6,2     
		2519,13788,8485,	// 7,3,4     
		2335,-14008,8171,	// 6,5,1     
		2335,14008,-8171,	// 0,10,8    
		2335,-14008,-8171,	// 0,5,9     
		2491,0,-16193,		// 0,9,10    
		11314,7321,-9318,	// 12,8,10   
		11314,-7321,-9318,	// 11,9,5    
		0,2032,16257,		// 18,20,8   
		0,-2032,16257,		// 17,11,5   
		0,-1809,-16284,		// 22,9,11   
		0,1809,-16284,		// 24,18,12  
		0,0,-16384,			// 24,10,9   
		-16384,0,0,			// 23,24,22  
		-11585,-11585,0,	// 23,20,24
		-11585,11585,0,		// 21,22,19
		-13354,3928,-8641,	// 18,24,20
		-13354,-3928,-8641,	// 17,19,22
		0,14654,7327,		// 7,8,20  
		0,-14654,7327,		// 6,21,19 
		0,0,16384,			// 21,6,7     
		0,16384,0,			// 16,15,14  
		0,-16384,0 };		// 16,13,14  
// --------------------------------- 
// Airplane Faces 
int AIRFACES[26*2+1+118] = { 26,
		C1,0,4,3,0,-1,			// Right Front  	
		C2,0,3,2,0,-1,			// Top Front  		
		C1,0,2,1,0,-1,			// Left Front  		
		C12,7,6,2,3,7,-1,		// Top Mid  		
		C6,7,3,4,8,7,-1,		// Right Upper Mid	
		C6,6,5,1,2,6,-1,		// Left Upper Mid	
		C8,0,10,8,0,-1,			// Right Lower Mid	
		C8,0,5,9,0,-1,			// Left Lower Mid	
		C9,0,9,10,0,-1,			// Bottom Mid		

		C1,12,8,10,12,-1,		// Right Front Wing
		C1,11,9,5,11,-1,		// Left Front Wing
		C3,18,20,8,12,18,-1,	// Right Top Wing	
		C3,17,11,5,19,17,-1,	// Left Top Wing

		C5,22,9,11,17,22,-1,	// Left Bottom Wing	
		C5,24,18,12,10,24,-1,	// Right Bottom Wing
		C7,24,10,9,22,24,-1,	// Bottom

		C4,23,24,22,21,23,-1,	// Center Rear
		C9,23,20,24,23,-1,		// Right Rear	
		C9,21,22,19,21,-1,		// Left Rear
		C7,18,24,20,18,-1,		// Right Rear Wing
		C7,17,19,22,17,-1,		// Left Rear Wing
		C14,7,8,20,23,7,-1,		// Right Inside Wing
		C14,6,21,19,5,6,-1,		// Left Inside Wing
		C15,21,6,7,23,21,-1,	// Top			

		C1,16,15,14,13,16,-1,	// Right Fin
		C2,16,13,14,15,16,-1  }; // Left Fin
// ---------------------------------
// Connect the normals to a vertex
int AIRNORGS[26] = {
		0,	// Right Front  	
		0,	// Top Front  		
		0,	// Left Front  		
		7,	// Top Mid  		
		7,	// Right Upper Mid	
		6,	// Left Upper Mid	
		0,	// Right Lower Mid	
		0,	// Left Lower Mid	
		0,	// Bottom Mid		

		12,	// Right Front Wing	
		11,	// Left Front Wing	
		18,	// Right Top Wing	
		17,	// Left Top Wing	

		22,	// Left Bottom Wing	
		24,	// Right Bottom Wing
		24,	// Bottom	

		23,	// Center Rear		
		23,	// Right Rear		
		21,	// Left Rear		

		18,	// Right Rear Wing	
		17,	// Left Rear Wing	
		7,	// Right Inside Wing
		6,	// Left Inside Wing	
		21,	// Top			

		16,	// Right Fin	
		16   }; // Left Fin	
// ========================================================================
// ========================================================================
// The Axes have 4 Points 
#define SC  5		// for object scaling

int AXES[16*3+1] = { 16,
		  0*SC,0*SC,0*SC,			// point 0 
		  100*SC,0*SC,0*SC,			// point 1 
		  0*SC,100*SC,0*SC,			// point 2 
		  0*SC,0*SC,100*SC,			// point 3 

		  110*SC,0*SC,-10*SC,		// point 4        'X' 
		  130*SC,0*SC,10*SC,		// point 5  
		  110*SC,0*SC,10*SC,		// point 6  
		  130*SC,0*SC,-10*SC,		// point 7  

		  0*SC,110*SC,15*SC,		// point 8        'Y'
		  0*SC,120*SC,0*SC,			// point 9    
		  0*SC,120*SC,-15*SC,		// point 10   
		  0*SC,130*SC,15*SC,		// point 11   

		  0*SC,-10*SC,125*SC,		// point 12       'Z'
		  0*SC,10*SC,125*SC,		// point 13  
		  0*SC,-10*SC,110*SC,		// point 14 
		  0*SC,10*SC,110*SC  };		// point 15  
// ---------------------------------
// Connect list for wire frame
int AXLINES[8*2+19+1] = { 8,
		  C1,0,1,-1,
		  C2,0,2,-1,
		  C4,0,3,-1,

		  C1,4,5,-1,	           // 'X' 
		  C1,6,7,-1,

		  C2,8,9,10,-1,            // 'Y' 
		  C2,9,11,-1,

		  C4,12,13,14,15,-1  };    // 'Z' 
// --------------------------------- 
// Dummy list for Axes Normals
int AXNORMS[1*3+1] = { 1,
		    0,0,0 };
// ---------------------------------
// Dummy list for Axes Faces
int AXFACES[6] = { 1,
		    C1,1,2,3,-1  };
// --------------------------------- 
// Dummy list for Axes normals to a vertex
int AXNORGS[2] = { 0,
		   0  };
// ------------------------------------------------------------------------
// ------------------------------------------------------------------------
#define NUM_POBJ	4

struct pobjs
{
	int *pts;		// object points 
	int *norms;		// normal vectors 
	int *faces;		// object face point list
	int *norgs;		// origin point number of normal	
	int *lines;		// wireframe connection list 
};
	
struct pobjs objtable[NUM_POBJ]=
{
   { SQ_P,SQNORMS,SQFACES,SQNORGS,SQLINES }, 	// Square 
   { CUBE_P,CNORMS,CFACES,CNORGS,CLINES }, 		// Cube 
   { AIR,AIRNORMS,AIRFACES,AIRNORGS,AIRLINES },	// Airplane 
   { AXES,AXNORMS,AXFACES,AXNORGS,AXLINES },    // Coordinate Axes
};
